/*---------------------------------------------------------------*
 | H8/3048F,3052F I/O address definition Release 2.2 2003-02-21  |
 |                                                               |
 |                   Copyright (c) 2000 BestTechnology CO.,LTD.  |
 *---------------------------------------------------------------*/

#ifndef _3048_H_
#define _3048_H_

#ifdef __cplusplus
extern "C" {
#endif

typedef unsigned long int _LONG;
typedef unsigned int      _WORD;
typedef unsigned char     _BYTE;

union _BITFIELD {
  _BYTE   BYTE;
  struct {
    _BYTE B7  :1;
    _BYTE B6  :1;
    _BYTE B5  :1;
    _BYTE B4  :1;
    _BYTE B3  :1;
    _BYTE B2  :1;
    _BYTE B1  :1;
    _BYTE B0  :1;
  }       BIT;
};

/*-------------------------------------------------------------------------
   DMARg[(DMAC)
 *-------------------------------------------------------------------------*/
struct st_sam {
  void        *MAR;
  _WORD       ETCR;
  _BYTE       IOAR;
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   DTE   :1;
      _BYTE   DTSZ  :1;
      _BYTE   DTID  :1;
      _BYTE   RPE   :1;
      _BYTE   DTIE  :1;
      _BYTE   DTS   :3;
    }         BIT;
  }           DTCR;
};

struct st_fam {         /* struct DMAC  */
  void        *MARA;
  _WORD       ETCRA;
  char        wk1;
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   DTE   :1;
      _BYTE   DTSZ  :1;
      _BYTE   SAID  :1;
      _BYTE   SAIDE :1;
      _BYTE   DTIE  :1;
      _BYTE   DTS   :3;
    }         BIT;
  }           DTCRA;
  void        *MARB;
  _WORD       ETCRB;
  char        wk2;
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   DTME  :1;
      _BYTE         :1;
      _BYTE   DAID  :1;
      _BYTE   DAIDE :1;
      _BYTE   TMS   :1;
      _BYTE   DTS   :3;
    }         BIT;
  }           DTCRB;
};

#define DMAC0A  (*(volatile struct st_sam   *)0xFFFF20) /* DMAC 0A Addr */
#define DMAC0B  (*(volatile struct st_sam   *)0xFFFF28) /* DMAC 0B Addr */
#define DMAC1A  (*(volatile struct st_sam   *)0xFFFF30) /* DMAC 1A Addr */
#define DMAC1B  (*(volatile struct st_sam   *)0xFFFF38) /* DMAC 1B Addr */

#define DMAC0   (*(volatile struct st_fam   *)0xFFFF20) /* DMAC 0  Addr */
#define DMAC1   (*(volatile struct st_fam   *)0xFFFF30) /* DMAC 1  Addr */

/*-------------------------------------------------------------------------
   tbV
 *-------------------------------------------------------------------------*/
union un_flmcr {        /* union FLMCR  */
  _BYTE       BYTE;
  struct {
    _BYTE     VPP   :1;
    _BYTE     VPPE  :1;
    _BYTE           :2;
    _BYTE     EV    :1;
    _BYTE     PV    :1;
    _BYTE     E     :1;
    _BYTE     P     :1;
  }           BIT;
};

union un_ebr1 {         /* union EBR1   */
  _BYTE       BYTE;
  struct {
    _BYTE     wk    :1;
    _BYTE     LB6   :1;
    _BYTE     LB5   :1;
    _BYTE     LB4   :1;
    _BYTE     LB3   :1;
    _BYTE     LB2   :1;
    _BYTE     LB1   :1;
    _BYTE     LB0   :1;
  }           BIT;
};

union un_ebr2 {         /* union EBR2   */
  _BYTE       BYTE;
  struct {
    _BYTE     SB7   :1;
    _BYTE     SB6   :1;
    _BYTE     SB5   :1;
    _BYTE     SB4   :1;
    _BYTE     SB3   :1;
    _BYTE     SB2   :1;
    _BYTE     SB1   :1;
    _BYTE     SB0   :1;
  }           BIT;
};

union un_ramcr {        /* union RAMCR  */
  _BYTE       BYTE;
  struct {
    _BYTE     FLER  :1;
    _BYTE           :3;
    _BYTE     RAMS  :1;
    _BYTE     RAM   :3;
  }           BIT;
};

#define FLMCR   (*(volatile union  un_flmcr *)0xFFFF40) /* FLMCR Address*/
#define EBR1    (*(volatile union  un_ebr1  *)0xFFFF42) /* EBR1  Address*/
#define EBR2    (*(volatile union  un_ebr2  *)0xFFFF43) /* EBR2  Address*/
#define RAMCR   (*(volatile union  un_ramcr *)0xFFFF48) /* RAMCR Address*/

/*-------------------------------------------------------------------------
   CeO[ebhE^C}Ejbg(ITU)
 *-------------------------------------------------------------------------*/
struct st_itu {
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   wk    :3;
      _BYTE   STR4  :1;
      _BYTE   STR3  :1;
      _BYTE   STR2  :1;
      _BYTE   STR1  :1;
      _BYTE   STR0  :1;
    }         BIT;
  }           TSTR;
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   wk    :3;
      _BYTE   SYNC4 :1;
      _BYTE   SYNC3 :1;
      _BYTE   SYNC2 :1;
      _BYTE   SYNC1 :1;
      _BYTE   SYNC0 :1;
    }         BIT;
  }           TSNC;
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   wk    :1;
      _BYTE   MDF   :1;
      _BYTE   FDIR  :1;
      _BYTE   PWM4  :1;
      _BYTE   PWM3  :1;
      _BYTE   PWM2  :1;
      _BYTE   PWM1  :1;
      _BYTE   PWM0  :1;
    }         BIT;
  }           TMDR;
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   wk    :2;
      _BYTE   CMD   :2;
      _BYTE   BFB4  :1;
      _BYTE   BFA4  :1;
      _BYTE   BFB3  :1;
      _BYTE   BFA3  :1;
    }         BIT;
  }           TFCR;
  char        wk[44];
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   wk    :2;
      _BYTE   EXB4  :1;
      _BYTE   EXA4  :1;
      _BYTE   EB3   :1;
      _BYTE   EB4   :1;
      _BYTE   EA4   :1;
      _BYTE   EA3   :1;
    }         BIT;
  }           TOER;
  union {
    _BYTE BYTE;
    struct {
      _BYTE   wk    :3;
      _BYTE   XTGD  :1;
      _BYTE         :2;
      _BYTE   OLS4  :1;
      _BYTE   OLS3  :1;
    }         BIT;
  }           TOCR;
};

struct st_itu0 {
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   wk    :1;
      _BYTE   CCLR  :2;
      _BYTE   CKEG  :2;
      _BYTE   TPSC  :3;
    }         BIT;
  }           TCR;
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   wk    :1;
      _BYTE   IOB   :3;
      _BYTE         :1;
      _BYTE   IOA   :3;
    }         BIT;
  }           TIOR;
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   wk    :5;
      _BYTE   OVIE  :1;
      _BYTE   IMIEB :1;
      _BYTE   IMIEA :1;
    }         BIT;
  }           TIER;
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   wk    :5;
      _BYTE   OVF   :1;
      _BYTE   IMFB  :1;
      _BYTE   IMFA  :1;
    }         BIT;
  }           TSR;
  _WORD       TCNT;
  _WORD       GRA;
  _WORD       GRB;
};

#define st_itu1 st_itu0
#define st_itu2 st_itu0

struct st_itu3 {
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   wk    :1;
      _BYTE   CCLR  :2;
      _BYTE   CKEG  :2;
      _BYTE   TPSC  :3;
    }         BIT;
  }           TCR;
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   wk    :1;
      _BYTE   IOB   :3;
      _BYTE         :1;
      _BYTE   IOA   :3;
    }         BIT;
  }           TIOR;
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   wk    :5;
      _BYTE   OVIE  :1;
      _BYTE   IMIEB :1;
      _BYTE   IMIEA :1;
    }         BIT;
  }           TIER;
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   wk    :5;
      _BYTE   OVF   :1;
      _BYTE   IMFB  :1;
      _BYTE   IMFA  :1;
    }         BIT;
  }           TSR;
  _WORD       TCNT;
  _WORD       GRA;
  _WORD       GRB;
  _WORD       BRA;
  _WORD       BRB;
  char        wk[2];
};

#define st_itu4 st_itu3

#define ITU     (*(volatile struct st_itu   *)0xFFFF60) /* ITU   Address*/
#define ITU0    (*(volatile struct st_itu0  *)0xFFFF64) /* ITU0  Address*/
#define ITU1    (*(volatile struct st_itu1  *)0xFFFF6E) /* ITU1  Address*/
#define ITU2    (*(volatile struct st_itu2  *)0xFFFF78) /* ITU2  Address*/
#define ITU3    (*(volatile struct st_itu3  *)0xFFFF82) /* ITU3  Address*/
#define ITU4    (*(volatile struct st_itu4  *)0xFFFF92) /* ITU4  Address*/

/*-------------------------------------------------------------------------
   vO}u^C~Op^[Rg[(TPC)
 *-------------------------------------------------------------------------*/
struct st_tpc {
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   wk    :4;
      _BYTE   G3NOV :1;
      _BYTE   G2NOV :1;
      _BYTE   G1NOV :1;
      _BYTE   G0NOV :1;
    }         BIT;
  }           TPMR;
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   G3CMS :2;
      _BYTE   G2CMS :2;
      _BYTE   G1CMS :2;
      _BYTE   G0CMS :2;
    }         BIT;
  }           TPCR;
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   B15   :1;
      _BYTE   B14   :1;
      _BYTE   B13   :1;
      _BYTE   B12   :1;
      _BYTE   B11   :1;
      _BYTE   B10   :1;
      _BYTE   B9    :1;
      _BYTE   B8    :1;
    }         BIT;
  }           NDERB;
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   B7    :1;
      _BYTE   B6    :1;
      _BYTE   B5    :1;
      _BYTE   B4    :1;
      _BYTE   B3    :1;
      _BYTE   B2    :1;
      _BYTE   B1    :1;
      _BYTE   B0    :1;
    }         BIT;
  }           NDERA;
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   B15   :1;
      _BYTE   B14   :1;
      _BYTE   B13   :1;
      _BYTE   B12   :1;
      _BYTE   B11   :1;
      _BYTE   B10   :1;
      _BYTE   B9    :1;
      _BYTE   B8    :1;
    }         BIT;
  }           NDRB1;
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   B7    :1;
      _BYTE   B6    :1;
      _BYTE   B5    :1;
      _BYTE   B4    :1;
      _BYTE   B3    :1;
      _BYTE   B2    :1;
      _BYTE   B1    :1;
      _BYTE   B0    :1;
    }         BIT;
  }           NDRA1;
  union {
    _BYTE BYTE;
    struct {
      _BYTE   wk    :4;
      _BYTE   B11   :1;
      _BYTE   B10   :1;
      _BYTE   B9    :1;
      _BYTE   B8    :1;
    }         BIT;
  }           NDRB2;
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   wk    :4;
      _BYTE   B3    :1;
      _BYTE   B2    :1;
      _BYTE   B1    :1;
      _BYTE   B0    :1;
    }         BIT;
  }           NDRA2;
};

#define TPC     (*(volatile struct st_tpc   *)0xFFFFA0) /* TPC   Address*/

/*-------------------------------------------------------------------------
   EHb`hbO^C}(WDT)
 *-------------------------------------------------------------------------*/
union un_wdt {
  struct {
    _WORD     TCSR;
    _WORD     RSTCSR;
  }           WRITE;
  struct {
    union {
      _BYTE   BYTE;
      struct {
        _BYTE OVF   :1;
        _BYTE WTIT  :1;
        _BYTE TME   :1;
        _BYTE       :1;
        _BYTE       :1;
        _BYTE CKS   :3;
      }       BIT;
    }         TCSR;
    _BYTE     TCNT;
    _BYTE     dum;
    _BYTE     RSTCSR;
  }           READ;
};

#define WDT     (*(volatile union un_wdt    *)0xFFFFA8) /* WDT   Address*/

/*-------------------------------------------------------------------------
   tbVRg[
 *-------------------------------------------------------------------------*/
struct st_rfshc {       /* struct RFSHC */
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   SRFMD :1;
      _BYTE   PSRAME:1;
      _BYTE   DRAME :1;
      _BYTE   CASWE :1;
      _BYTE   M9M8  :1;
      _BYTE   PFSHE :1;
      _BYTE         :1;
      _BYTE   RCYCE :1;
    }         BIT;
  }           RFSHCR;
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   CMF   :1;
      _BYTE   CMIE  :1;
      _BYTE   CKS   :3;
    }         BIT;
  }           RTMCSR;
  _BYTE       RTCNT;
  _BYTE       RTCOR;
};

#define RFSHC   (*(volatile struct st_rfshc *)0xFFFFAC)

/*-------------------------------------------------------------------------
   VAR~jP[VC^tF[X(SCI)
 *-------------------------------------------------------------------------*/
struct st_sci {
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   CA    :1;
      _BYTE   CHR   :1;
      _BYTE   PE    :1;
      _BYTE   OE    :1;
      _BYTE   STOP  :1;
      _BYTE   MP    :1;
      _BYTE   CKS   :2;
    }         BIT;
  }           SMR;
  _BYTE       BRR;
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   TIE   :1;
      _BYTE   RIE   :1;
      _BYTE   TE    :1;
      _BYTE   RE    :1;
      _BYTE   MPIE  :1;
      _BYTE   TEIE  :1;
      _BYTE   CKE   :2;
    }         BIT;
  }           SCR;
  _BYTE       TDR;
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   TDRE  :1;
      _BYTE   RDRF  :1;
      _BYTE   ORER  :1;
      _BYTE   FER   :1;
      _BYTE   PER   :1;
      _BYTE   TEND  :1;
      _BYTE   MPB   :1;
      _BYTE   MPBT  :1;
    }         BIT;
  }           SSR;
  _BYTE       RDR;
  char        wk[2];
};

#define SCI0    (*(volatile struct st_sci   *)0xFFFFB0)
#define SCI1    (*(volatile struct st_sci   *)0xFFFFB8)

/*-------------------------------------------------------------------------
   I/O|[g
 *-------------------------------------------------------------------------*/
struct st_p1 {
  _BYTE      DDR;
  char       wk;
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   B7    :1;
      _BYTE   B6    :1;
      _BYTE   B5    :1;
      _BYTE   B4    :1;
      _BYTE   B3    :1;
      _BYTE   B2    :1;
      _BYTE   B1    :1;
      _BYTE   B0    :1;
    }         BIT;
  }           DR;
};

struct st_p2 {
  _BYTE       DDR;
  char        wk1;
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   B7    :1;
      _BYTE   B6    :1;
      _BYTE   B5    :1;
      _BYTE   B4    :1;
      _BYTE   B3    :1;
      _BYTE   B2    :1;
      _BYTE   B1    :1;
      _BYTE   B0    :1;
    }         BIT;
  }           DR;
  char        wk2[20];
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   B7    :1;
      _BYTE   B6    :1;
      _BYTE   B5    :1;
      _BYTE   B4    :1;
      _BYTE   B3    :1;
      _BYTE   B2    :1;
      _BYTE   B1    :1;
      _BYTE   B0    :1;
    }         BIT;
  }           PCR;
};

#define st_p3   st_p1

struct st_p4 {
  _BYTE       DDR;
  char        wk1;
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   B7    :1;
      _BYTE   B6    :1;
      _BYTE   B5    :1;
      _BYTE   B4    :1;
      _BYTE   B3    :1;
      _BYTE   B2    :1;
      _BYTE   B1    :1;
      _BYTE   B0    :1;
    }         BIT;
  }           DR;
  char        wk2[18];
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   B7    :1;
      _BYTE   B6    :1;
      _BYTE   B5    :1;
      _BYTE   B4    :1;
      _BYTE   B3    :1;
      _BYTE   B2    :1;
      _BYTE   B1    :1;
      _BYTE   B0    :1;
    }         BIT;
  }           PCR;
};

struct st_p5 {
  _BYTE       DDR;
  char        wk1;
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   wk    :4;
      _BYTE   B3    :1;
      _BYTE   B2    :1;
      _BYTE   B1    :1;
      _BYTE   B0    :1;
    }         BIT;
  }           DR;
  char        wk2[16];
  union {
    _BYTE BYTE;
    struct {
      _BYTE   wk    :4;
      _BYTE   B3    :1;
      _BYTE   B2    :1;
      _BYTE   B1    :1;
      _BYTE   B0    :1;
    }         BIT;
  }           PCR;
};

struct st_p6 {
  _BYTE       DDR;
  char        wk;
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   wk    :1;
      _BYTE   B6    :1;
      _BYTE   B5    :1;
      _BYTE   B4    :1;
      _BYTE   B3    :1;
      _BYTE   B2    :1;
      _BYTE   B1    :1;
      _BYTE   B0    :1;
    }         BIT;
  }           DR;
};

struct st_p7 {
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   B7    :1;
      _BYTE   B6    :1;
      _BYTE   B5    :1;
      _BYTE   B4    :1;
      _BYTE   B3    :1;
      _BYTE   B2    :1;
      _BYTE   B1    :1;
      _BYTE   B0    :1;
    }         BIT;
  }           DR;
};

struct st_p8 {
  _BYTE       DDR;
  char        wk;
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   wk    :3;
      _BYTE   B4    :1;
      _BYTE   B3    :1;
      _BYTE   B2    :1;
      _BYTE   B1    :1;
      _BYTE   B0    :1;
    }         BIT;
  }           DR;
};

struct st_p9 {
  _BYTE       DDR;
  char        wk;
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   wk    :2;
      _BYTE   B5    :1;
      _BYTE   B4    :1;
      _BYTE   B3    :1;
      _BYTE   B2    :1;
      _BYTE   B1    :1;
      _BYTE   B0    :1;
    }         BIT;
  }           DR;
};

#define st_pa   st_p1
#define st_pb   st_p1

#define P1      (*(volatile struct st_p1    *)0xFFFFC0)
#define P2      (*(volatile struct st_p2    *)0xFFFFC1)
#define P3      (*(volatile struct st_p1    *)0xFFFFC4)
#define P4      (*(volatile struct st_p4    *)0xFFFFC5)
#define P5      (*(volatile struct st_p5    *)0xFFFFC8)
#define P6      (*(volatile struct st_p6    *)0xFFFFC9)
#define P7      (*(volatile struct st_p7    *)0xFFFFCE)
#define P8      (*(volatile struct st_p8    *)0xFFFFCD)
#define P9      (*(volatile struct st_p9    *)0xFFFFD0)
#define PA      (*(volatile struct st_p1    *)0xFFFFD1)
#define PB      (*(volatile struct st_p1    *)0xFFFFD4)

/*-------------------------------------------------------------------------
   D/ARo[^(DAC)
 *-------------------------------------------------------------------------*/
struct st_da {
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   wk    :7;
      _BYTE   DASTE :1;
    }         BIT;
  }           STCR;
  char        wk[127];
  _BYTE       DR0;
  _BYTE       DR1;
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   DAOE1 :1;
      _BYTE   DAOE0 :1;
      _BYTE   DAE   :1;
    }         BIT;
  }           CR;
};

#define DA      (*(volatile struct st_da    *)0xFFFF5C)

/*-------------------------------------------------------------------------
   A/DRo[^(ADC)
 *-------------------------------------------------------------------------*/
struct st_ad {
  _WORD       DRA;
  _WORD       DRB;
  _WORD       DRC;
  _WORD       DRD;
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   ADF   :1;
      _BYTE   ADIE  :1;
      _BYTE   ADST  :1;
      _BYTE   SCAN  :1;
      _BYTE   CKS   :1;
      _BYTE   CH    :3;
    }         BIT;
  }           CSR;
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   TRGE  :1;
    }         BIT;
  }           CR;
};

#define AD      (*(volatile struct st_ad    *)0xFFFFE0)

/*-------------------------------------------------------------------------
   oXRg[(BSC)
 *-------------------------------------------------------------------------*/
struct st_bsc {                                         /* struct BSC   */
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   CS7E  :1;
      _BYTE   CS6E  :1;
      _BYTE   CS5E  :1;
      _BYTE   CS4E  :1;
    }         BIT;
  }           CSCR;
  char        wk1[140];
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   B7    :1;
      _BYTE   B6    :1;
      _BYTE   B5    :1;
      _BYTE   B4    :1;
      _BYTE   B3    :1;
      _BYTE   B2    :1;
      _BYTE   B1    :1;
      _BYTE   B0    :1;
    }         BIT;
  }           ABWCR;
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   B7    :1;
      _BYTE   B6    :1;
      _BYTE   B5    :1;
      _BYTE   B4    :1;
      _BYTE   B3    :1;
      _BYTE   B2    :1;
      _BYTE   B1    :1;
      _BYTE   B0    :1;
    }         BIT;
  }           ASTCR;
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   wk    :4;
      _BYTE   WMS   :2;
      _BYTE   WC    :2;
    }         BIT;
  }           WCR;
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   B7    :1;
      _BYTE   B6    :1;
      _BYTE   B5    :1;
      _BYTE   B4    :1;
      _BYTE   B3    :1;
      _BYTE   B2    :1;
      _BYTE   B1    :1;
      _BYTE   B0    :1;
    }         BIT;
  }           WCER;
  char        wk2[3];
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   A23E  :1;
      _BYTE   A22E  :1;
      _BYTE   A21E  :1;
      _BYTE         :4;
      _BYTE   BRLE  :1;
    }         BIT;
  }           BRCR;
};

#define BSC     (*(volatile struct st_bsc   *)0xFFFF5F) /* BSC   Address*/

/*-------------------------------------------------------------------------
   NbNU
 *-------------------------------------------------------------------------*/
union un_divcr {                                        /* union DIVCR  */
  _BYTE       BYTE;
  struct {
    _BYTE     wk    :6;
    _BYTE     DIV   :2;
  }           BIT;
};

#define DIVCR   (*(volatile union  un_divcr *)0xFFFF5D) /* DIVCR Address*/

/*-------------------------------------------------------------------------
   d͏
 *-------------------------------------------------------------------------*/
union un_syscr {                                        /* union SYSCR  */
  _BYTE       BYTE;
  struct {
    _BYTE     SSBY  :1;
    _BYTE     STS   :3;
    _BYTE     UE    :1;
    _BYTE     NMIEG :1;
    _BYTE           :1;
    _BYTE     RAME  :1;
  }           BIT;
};

#define SYSCR   (*(volatile union  un_syscr *)0xFFFFF2) /* SYSCR Address*/

union un_mstcr {                                        /* union MSTCR  */
  _BYTE       BYTE;
  struct {
    _BYTE     PSTOP :1;
    _BYTE           :1;
    _BYTE     MSTOP5:1;
    _BYTE     MSTOP4:1;
    _BYTE     MSTOP3:1;
    _BYTE     MSTOP2:1;
    _BYTE     MSTOP1:1;
    _BYTE     MSTOP0:1;
  }           BIT;
};

#define MSTCR   (*(volatile union  un_mstcr *)0xFFFF5E) /* MSTCR Address*/

/*-------------------------------------------------------------------------
   MCU샂[h(MCU)
 *-------------------------------------------------------------------------*/
union un_mdcr {                                         /* union MDCR   */
  _BYTE       BYTE;
  struct {
    _BYTE     wk    :5;
    _BYTE     MDS   :3;
  }           BIT;
};

#define MDCR    (*(volatile union  un_mdcr  *)0xFFFFF1) /* MDCR  Address*/

/*-------------------------------------------------------------------------
   荞݃Rg[(INTC)
 *-------------------------------------------------------------------------*/
struct st_intc {                                        /* struct INTC  */
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   wk    :2;
      _BYTE   IRQ5SC:1;
      _BYTE   IRQ4SC:1;
      _BYTE   IRQ3SC:1;
      _BYTE   IRQ2SC:1;
      _BYTE   IRQ1SC:1;
      _BYTE   IRQ0SC:1;
    }         BIT;
  }           ISCR;
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   wk   :2;
      _BYTE   IRQ5E:1;
      _BYTE   IRQ4E:1;
      _BYTE   IRQ3E:1;
      _BYTE   IRQ2E:1;
      _BYTE   IRQ1E:1;
      _BYTE   IRQ0E:1;
    }         BIT;
  }           IER;
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   wk   :2;
      _BYTE   IRQ5F:1;
      _BYTE   IRQ4F:1;
      _BYTE   IRQ3F:1;
      _BYTE   IRQ2F:1;
      _BYTE   IRQ1F:1;
      _BYTE   IRQ0F:1;
    }         BIT;
  }           ISR;
  char        wk;
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   B7    :1;
      _BYTE   B6    :1;
      _BYTE   B5    :1;
      _BYTE   B4    :1;
      _BYTE   B3    :1;
      _BYTE   B2    :1;
      _BYTE   B1    :1;
      _BYTE   B0    :1;
    }         BIT;
  }           IPRA;
  union {
    _BYTE     BYTE;
    struct {
      _BYTE   B7    :1;
      _BYTE   B6    :1;
      _BYTE   B5    :1;
      _BYTE         :1;
      _BYTE   B3    :1;
      _BYTE   B2    :1;
      _BYTE   B1    :1;
    }         BIT;
  }           IPRB;
};

#define INTC    (*(volatile struct st_intc  *)0xFFFFF4) /* INTC  Address*/

#define DI  asm("orc.b #0xc0,ccr")
#define EI  asm("andc.b #0x3f,ccr")

/*--------------------------------------------------------------*/
/* 荞݊֐vg^Cv錾                                 */
/*--------------------------------------------------------------*/
// NMI荞
extern void int_nmi (void)    asm ("_int_nmi")    __attribute__((interrupt_handler));
/*
// gbv
extern void int_trap0 (void) asm ("_int_trap0") __attribute__((interrupt_handler));
extern void int_trap1 (void) asm ("_int_trap1") __attribute__((interrupt_handler));
extern void int_trap2 (void) asm ("_int_trap2") __attribute__((interrupt_handler));
extern void int_trap3 (void) asm ("_int_trap3") __attribute__((interrupt_handler));
*/
// IRQ0`5O荞
extern void int_irq0 (void)   asm ("_int_irq0")   __attribute__((interrupt_handler));
extern void int_irq1 (void)   asm ("_int_irq1")   __attribute__((interrupt_handler));
extern void int_irq2 (void)   asm ("_int_irq2")   __attribute__((interrupt_handler));
extern void int_irq3 (void)   asm ("_int_irq3")   __attribute__((interrupt_handler));
extern void int_irq4 (void)   asm ("_int_irq4")   __attribute__((interrupt_handler));
extern void int_irq5 (void)   asm ("_int_irq5")   __attribute__((interrupt_handler));
// EHb`hbO^C} (C^[o^C})
extern void int_wovi (void)   asm ("_int_wovi")   __attribute__((interrupt_handler));
// tbVRg[ (RyA}b`)
extern void int_cmi (void)    asm ("_int_cmi")    __attribute__((interrupt_handler));

// ITU0 (RyA}b`/CvbgLv`A0)
extern void int_imia0 (void)  asm ("_int_imia0")  __attribute__((interrupt_handler));
// ITU0 (RyA}b`/CvbgLv`B0)
extern void int_imib0 (void)  asm ("_int_imib0")  __attribute__((interrupt_handler));
// ITU0 (I[ot[0)
extern void int_ovi0 (void)   asm ("_int_ovi0")   __attribute__((interrupt_handler));

// ITU1 (RyA}b`/CvbgLv`A1)
extern void int_imia1 (void)  asm ("_int_imia1")  __attribute__((interrupt_handler));
// ITU1 (RyA}b`/CvbgLv`B1)
extern void int_imib1 (void)  asm ("_int_imib1")  __attribute__((interrupt_handler));
// ITU1 (I[ot[1)
extern void int_ovi1 (void)   asm ("_int_ovi1")   __attribute__((interrupt_handler));

// ITU2 (RyA}b`/CvbgLv`A2)
extern void int_imia2 (void)  asm ("_int_imia2")  __attribute__((interrupt_handler));
// ITU2 (RyA}b`/CvbgLv`B2)
extern void int_imib2 (void)  asm ("_int_imib2")  __attribute__((interrupt_handler));
// ITU2 (I[ot[2)
extern void int_ovi2 (void)   asm ("_int_ovi2")   __attribute__((interrupt_handler));

// ITU3 (RyA}b`/CvbgLv`A3)
extern void int_imia3 (void)  asm ("_int_imia3")  __attribute__((interrupt_handler));
// ITU3 (RyA}b`/CvbgLv`B3)
extern void int_imib3 (void)  asm ("_int_imib3")  __attribute__((interrupt_handler));
// ITU3 (I[ot[3)
extern void int_ovi3 (void)   asm ("_int_ovi3")   __attribute__((interrupt_handler));

// ITU4 (RyA}b`/CvbgLv`A4)
extern void int_imia4 (void)  asm ("_int_imia4")  __attribute__((interrupt_handler));
// ITU4 (RyA}b`/CvbgLv`B4)
extern void int_imib4 (void)  asm ("_int_imib4")  __attribute__((interrupt_handler));
// ITU4 (I[ot[4)
extern void int_ovi4 (void)   asm ("_int_ovi4")   __attribute__((interrupt_handler));

// DMAC0 (DMAC0/DMAC0A])
extern void int_dend0a (void) asm ("_int_dend0a") __attribute__((interrupt_handler));
// DMAC0 (DMAC0B])
extern void int_dend0b (void) asm ("_int_dend0b") __attribute__((interrupt_handler));
// DMAC1 (DMAC1/DMAC1A])
extern void int_dend1a (void) asm ("_int_dend1a") __attribute__((interrupt_handler));
// DMAC1 (DMAC1B])
extern void int_dend1b (void) asm ("_int_dend1b") __attribute__((interrupt_handler));

// SCI0 (MG[0)
extern void int_eri0 (void)   asm ("_int_eri0")   __attribute__((interrupt_handler));
// SCI0 (Mf[^t0)
extern void int_rxi0 (void)   asm ("_int_rxi0")   __attribute__((interrupt_handler));
// SCI0 (Mf[^GveB0)
extern void int_txi0 (void)   asm ("_int_txi0")   __attribute__((interrupt_handler));
// SCI0 (MI0)
extern void int_tei0 (void)   asm ("_int_tei0")   __attribute__((interrupt_handler));

// SCI1 (MG[1)
extern void int_eri1 (void)   asm ("_int_eri1")   __attribute__((interrupt_handler));
// SCI1 (Mf[^t1)
extern void int_rxi1 (void)   asm ("_int_rxi1")   __attribute__((interrupt_handler));
// SCI1 (Mf[^GveB1)
extern void int_txi1 (void)   asm ("_int_txi1")   __attribute__((interrupt_handler));
// SCI1 (MI1)
extern void int_tei1 (void)   asm ("_int_tei1")   __attribute__((interrupt_handler));

// A/D (A/D)
extern void int_adi (void)    asm ("_int_adi")    __attribute__((interrupt_handler));

/*--------------------------------------------------------------*/
/* VAʐM֐(FIFOobt@t)                             */
/*--------------------------------------------------------------*/

// {[[gݒ胊Xg
#ifdef SYS_CLOCK_14_7456
// NbN14.7456MHz
typedef enum {
  br2400   = 191,
  br4800   = 95,
  br9600   = 47,
  br19200  = 23,
  br31250  = 14,
  br38400  = 11,
  br57600  = 7
} TBaudRate;
#else
#define SYS_CLOCK_16
// NbN16MHz
typedef enum {
  br2400   = 207,
  br4800   = 103,
  br9600   = 51,
  br19200  = 25,
  br31250  = 15,
  br38400  = 12,
  br57600  = 8
} TBaudRate;
#endif

#ifdef SYS_CLOCK_24_576
typedef enum {
  br4800  = 159,
  br9600  = 79,
  br19200 = 39,
  br31250 = 24,
  br38400 = 19,
  br57600 = 12
} TBaudRate;
#else
#ifndef SYS_CLOCK_16
#define SYS_CLOCK_16
// NbN16MHz
typedef enum {
  br2400   = 207,
  br4800   = 103,
  br9600   = 51,
  br19200  = 25,
  br31250  = 15,
  br38400  = 12,
  br57600  = 8
} TBaudRate;
#endif
#endif

// SCI
extern void SCI0_INIT (TBaudRate, char *, short, char *, short);
extern void SCI1_INIT (TBaudRate, char *, short, char *, short);
// 1M
extern void SCI0_OUT_DATA (char);
extern void SCI1_OUT_DATA (char);
// 񑗐M
extern void SCI0_OUT_STRING (char *);
extern void SCI1_OUT_STRING (char *);
// oCi񑗐M
extern void SCI0_OUT_STRINGB (char *, short);
extern void SCI1_OUT_STRINGB (char *, short);
// Mobt@`FbN
extern short SCI0_IN_DATA_CHECK (void);
extern short SCI1_IN_DATA_CHECK (void);
// Mobt@`FbN
extern short SCI0_OUT_DATA_CHECK (void);
extern short SCI1_OUT_DATA_CHECK (void);
// Mobt@NA
extern void SCI0_IN_DATA_CLEAR (void);
extern void SCI1_IN_DATA_CLEAR (void);
// Mobt@NA
extern void SCI0_OUT_DATA_CLEAR (void);
extern void SCI1_OUT_DATA_CLEAR (void);
// 1M
extern char SCI0_IN_DATA (void);
extern char SCI1_IN_DATA (void);
// 񑗐M
extern short SCI0_IN_STRING (char *, short);
extern short SCI1_IN_STRING (char *, short);
// ȈՃtH[}bgo
extern int SCI0_PRINTF (const char *, ...);
extern int SCI1_PRINTF (const char *, ...);


#ifdef __cplusplus
}
#endif

#endif /* _3048_H_ */
